// This file takes the ClassIds.txt file, parses it, and retrieves the clsid of each 
// OWCOM API object and produces a safe4scripting.reg file.

var fso, f1, f2, s, counter, singleLineString, clsidStartPosition, clsid;
var ForReading = 1;
var str1 = "[HKEY_CLASSES_ROOT\\CLSID\\{";
var str2 = "}\\Implemented Categories\\{7DD95801-9882-11CF-9FA9-00AA006C42C4}]";
var str3 = "}\\Implemented Categories\\{7DD95802-9882-11CF-9FA9-00AA006C42C4}]";
// Instantiate a File System Object 
fso = WScript.CreateObject("Scripting.FileSystemObject");
// Create registry file and get handle to it
f1 = fso.CreateTextFile("safe4scripting.reg", true);
// Get a handle to the ClassIds.txt file to parse 
f2 = fso.OpenTextFile("ClassIds.txt", ForReading); // this is a text stream, not a file


// Parse ClassIds.txt and retrieve all the classids and put them in a file 
WScript.Echo("Writing file"); 
// Write a line. 
f1.WriteLine("REGEDIT4");
f1.WriteBlankLines(1);
counter = 0;
clsidStartPosition = 0;
do
{
   // read each line of the file
   singleLineString = f2.ReadLine();
   // retrieve the index where the substring "clsid=" starts
   clsidStartPosition = singleLineString.indexOf("clsid=");
   // retrieve the substring of the clsid, which is 36 characters long
   if (clsidStartPosition > 0) // if we found a clsid on this line...
   {
      // add 6 to index the character right after the equals sign
      clsidStartPosition = clsidStartPosition + 6;
      clsid = singleLineString.substr(clsidStartPosition, 36);
      f1.WriteLine(str1 + clsid + str2);
      f1.WriteLine(str1 + clsid + str3);
      f1.WriteBlankLines(1);
   }
} 
while (!f2.AtEndOfStream);
 
// Close both file streams. 
f1.Close(); 
f2.Close();
WScript.Echo("All done!");


 


